// -*- C++ -*- //

#ifndef ALGOBOX_H
#define ALGOBOX_H

class AlgoBox;

#include <all_include.h>
#include <mapstorage.h>
#include <mapselector.h>
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

class AlgoBox : public Gtk::VBox
{
  sigc::signal<void, std::string> signal_maplist_need;  
  sigc::signal<void, std::string, bool> signal_newmapwin_need;  

protected:
  Gtk::ComboBoxText tabcbt;
  std::vector<MapSelector *> nodemapcbts;
  std::vector<MapSelector *> edgemapcbts;

  MapStorage * mapstorage;

public:
  AlgoBox(){};
  AlgoBox(std::vector<std::string>);

  virtual void init(std::vector<std::string>);

  sigc::signal<void, std::string> signal_maplist_needed();  
  sigc::signal<void, std::string, bool> signal_newmapwin_needed(){return signal_newmapwin_need;};  
  void emit_tab_change();

  void update_tablist( std::vector< std::string > tl );
  void update_maplist( MapStorage * );

  void nodemaplist_changed(std::string);
  void edgemaplist_changed(std::string);

  void update_cbt( std::vector< std::string > tl, Gtk::ComboBoxText &);
  
  virtual void run();
  
  virtual void build_box();

  virtual void emit_new_map_signal(bool);

  void addMapSelector(std::string, bool);
};
#endif //ALGOBOX_H
